#include <iostream>
#include <cmath>
#include <set>
#include <algorithm>
#include <cassert>
#include <vector>
#include <fstream>
#include <fstream>
#include <iomanip>
#include <cstdlib>
#include <ctime>
using namespace std;
#define rep(i,a,b) for(int i=a;i<b;++i)
#define MP(x,y) make_pair(x,y)
#define FI(x) (x).first
#define SE(x) (x).second
#define SORT(x) sort((x).begin(), (x).end())
#define ALL(X) (X).begin() (X).end()

typedef float fl;
typedef vector<int> vi;
typedef vector<vi> vvi;
fl eps=1e-6;

//not done: include i : N(i) \subseteq N(I\p). lp_solve does this by magic coincidence in most cases

int m,n;
fl a[512][512], r[512], c[512];

template<typename t>ostream& operator<<(ostream& os, const vector<t>& v) { rep(i,0,v.size()) os << v[i] << ' '; return os; }

ostream& operator<<(ostream& os, const set<int>& s) {
	for(set<int>::const_iterator it = s.begin(); it != s.end(); ++it)
		os << (*it) << ' ';
	return os;
}

fl rnd() {
	return fl(rand()) / fl(RAND_MAX);
}

void rnd_init() {
	rep(i,0,m) rep(j,0,n) {
		if(rand() % 16 < 15) {
			a[i][j] = 0;
		} else {
			a[i][j] = 1;
		}
	}
	rep(i,0,m) a[i][rand()%n] = 1;
	rep(j,0,n) a[rand()%m][j] = 1;
	fl rs = 0, cs = 0;
	rep(i,0,m) { r[i] = rand()%300 + 1; rs += r[i]; }
	rep(j,0,n) { c[j] = rand()%300+1; cs += c[j]; }
	if(rs < cs - 1e-3) {
		r[m-1] += cs-rs;
	} else if(rs > cs + 1e-3) {
		c[n-1] += rs-cs;
	}
}

void fix_rows() {
	rep(i,0,m) { fl s = 0; rep(j,0,n) s += a[i][j]; rep(j,0,n) a[i][j] *= r[i]/s; } 
}

void fix_cols() {
	rep(j,0,n) { fl s = 0; rep(i,0,m) s += a[i][j]; rep(i,0,m) a[i][j] *= c[j]/s; }
}


void truncate() { rep(i,0,m) rep(j,0,n) if(a[i][j] < 1e-15) a[i][j] = 0; }

void print(ostream& os = cout) {
	os << setprecision(2);
	rep(i,0,m) {
		rep(j,0,n) {
			os << setw(8) << right << a[i][j];
		}
		os << endl;
	}

	os << setprecision(4);

	rep(i,0,m) os << r[i] << ' '; os << endl;
	rep(j,0,n) os << c[j] << ' '; os << endl;

}

fl abs_(fl x) { return x > 0 ? x : -x; }

fl error() {
	fl rt = 0;
	rep(i,0,m) {
		fl s = 0;
		rep(j,0,n)
			s += a[i][j];
		rt += (s-r[i])*(s-r[i]);
		//rt += abs_(s-r[i]);
	}
	rep(j,0,n) {
		fl s = 0;
		rep(i,0,m)
			s += a[i][j];
		rt += (s-c[j])*(s-c[j]);
		//rt += abs_(s-c[j]);
	}
	return rt;
}

vi range(int L) { vi rt(L);rep(t,0,L) rt[t] = t;return rt;}
fl _r(vi I) { fl rt = 0; rep(i,0,I.size()) rt += r[I[i]]; return rt; }
fl _c(vi J) { fl rt = 0; rep(j,0,J.size()) rt += c[J[j]]; return rt; }
bool eq(fl x, fl y) {return abs_(x-y)<eps;}


pair<vi,vi> split(vi rows, vi cols, fl multiplier) {
	vi rt_row, rt_col;
	ofstream prog("tmp.txt");	
	prog << "min: ";
	rep(i,0,rows.size()) {
		prog << r[rows[i]] << "* x"<<i<<"+";
	}
	rep(j,0,cols.size()) {
		prog << (multiplier*c[cols[j]]) << "* y" << j;
		if(j != cols.size()-1) prog << " +";
	}
	prog << ";" << endl;
	rep(i,0,rows.size()) rep(j,0,cols.size()) if(a[rows[i]][cols[j]] != 0)
		prog << "x"<<i << " + y"<<j <<" >= 1;" << endl;
	prog.close();
	system("lp_solve <tmp.txt >temp.txt");
	ifstream sol("temp.txt");
	string foo; rep(T,0,4) getline(sol,foo);
	rep(i,0,rows.size()) {
		sol >> foo;
		int decide; sol >> decide;
		if(!decide) rt_row.push_back(rows[i]);
	}
	rep(j,0,cols.size()) {
		sol >> foo;
		int decide; sol >> decide;
		if(decide) rt_col.push_back(cols[j]);
	}
	sol.close();
	return MP(rt_row, rt_col);
}

void read_file(string path) {
	ifstream file(path.c_str());
	file >> m >> n;
	rep(i,0,m) file >> r[i];
	rep(j,0,n) file >> c[j];
	rep(i,0,m)rep(j,0,n)
		file >> a[i][j];
	file.close();
}


int main() {
	srand(time(0));
	m = 5, n = 5;
	//rnd_init();
	read_file("T11in.txt");
	print();
/*
	vvi II, JJ;
	set<int>I, J;rep(i,0,m)I.insert(i);rep(j,0,n)J.insert(j);
	while(I.size() > 0) {
		assert(J.size() > 0);
		vi Ip(I.begin(),I.end()), Jp(J.begin(), J.end());
		while(true) {
			pair<vi,vi> P = split(Ip, Jp, _r(Ip) / _c(Jp));
			fl r1 = _r(FI(P)), r2 = _r(Ip) - r1,
				 c1 = _c(SE(P)), c2 = _c(Jp) - c1;
			if(eq(r1,0) || eq(r2,0) || eq(c1, 0) || eq(c2,0)) {
				break;
			} else if(r1/c1>=r2/c2) {
				Ip = FI(P), Jp = SE(P);
			} else {
				assert(false);
				set<int> A(Ip.begin(), Ip.end()), B(Jp.begin(), Jp.end());
				rep(i,0,FI(P).size()) A.erase((FI(P))[i]);
				rep(j,0,SE(P).size()) B.erase((SE(P))[j]);
				Ip = vi(A.begin(), A.end()), Jp = vi(B.begin(), B.end());
			}
		}
		SORT(Ip), SORT(Jp);
		II.push_back(Ip), JJ.push_back(Jp);
		rep(i,0,Ip.size()) I.erase(Ip[i]); rep(j,0,Jp.size()) J.erase(Jp[j]);
	}

	rep(k,0,II.size())
		cout << "I_" << k << " : " << II[k] << endl;
	rep(k,0,JJ.size())
		cout << "J_" << k << " : " << JJ[k] << endl;

	rep(k,0,II.size()) {
		rep(l,0,JJ.size()) {
			if(k != l) {
				bool iz = true;
				rep(i,0,II[k].size()) rep(j,0,JJ[l].size())
					if(!eq(0,a[II[k][i]][JJ[l][j]]))
						iz = false;
				if(iz) cout << "0 ";
				else cout << "* ";
			} else {
				cout << "1 ";
			}
		}
		cout << endl;
	}

	rep(k,0,II.size()) {
		cout << (_r(II[k]) / _c(JJ[k])) << endl;
	}
*/
	cout << "before" << endl;
	print();
/*
	rep(k,0,II.size()) {		rep(l,0,JJ.size()) {		fl s = 0;
		rep(i,0,II[k].size()) rep(j,0,JJ[l].size())			s += a[II[k][i]][JJ[l][j]];
		cout << (!eq(s,0)) << ' ';		}
		cout << endl;	}
*/
	rep(T,0,2) fix_rows(), fix_cols();

cout << setprecision(8);
print();
/*
	rep(k,0,II.size()) {		rep(l,0,JJ.size()) {		fl s = 0;
		rep(i,0,II[k].size()) rep(j,0,JJ[l].size())			s += a[II[k][i]][JJ[l][j]];
		cout << setw(7) << right << s << ' ';
		}	
		cout << endl;	}
	*/
	//system("rm tmp.txt temp.txt");

return 0;
}
